from ngsolve import *
import netgen.geom2d as geom2d

mesh = Mesh(geom2d.unit_square.GenerateMesh(maxh=0.25))

order = 3

# For the Surface->Volume map we need at least order 1!
L = L2(mesh, order=order)
S = SurfaceL2(mesh, order=order)

## Volume -> Surface (this should work without the hacky stuff)
# We can use FacetFESpace as a go-between because it has boundary elements.
F = FacetFESpace(mesh, order=order, dirichlet=".*")
# first L2 -> FacetFESpace
V2S_1 = comp.ConvertOperator(spacea=L, spaceb=F, trial_cf=InnerProduct(L.TrialFunction().Deriv(), specialcf.normal(mesh.dim)))
# then FacetFESpace -> SurfaceL2
V2S_2 = comp.ConvertOperator(spacea=F, spaceb=S, vb=BND)
V2S = V2S_2 @ V2S_1

gfL = GridFunction(L)
gfL.Set(x)
gfS = GridFunction(S)
gfS.vec.data = V2S * gfL.vec

# For visualization convert back to volume L2 (this needs the hacky stuff)
Hd = Discontinuous(H1(mesh, order=max(1, order)), keep_bnd_els=True)
S2V_1 = comp.ConvertOperator(spacea=S, spaceb=Hd, vb=BND)
S2V_2 = comp.ConvertOperator(spacea=Hd, spaceb=L)
S2V = S2V_2 @ S2V_1

gfL.vec.data = S2V * gfS.vec
Draw(gfL, mesh, "gfL")
